<?php
require 'geoip2/autoload.php';

use MaxMind\Db\Reader;

// Path to the GeoIP2 City database file
$databasePath = 'geoip2/GeoLite2-City.mmdb';

if($_REQUEST['ip']){
    $clientIp = $_REQUEST['ip'];
}else{
// Get client's IP address
if (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
    $clientIp = $_SERVER['HTTP_X_FORWARDED_FOR'];
} else {
    $clientIp = $_SERVER['REMOTE_ADDR'];
}
}

// Create a reader for the GeoIP2 City database
$reader = new Reader($databasePath);
$databasePath2 = 'geoip2/GeoLite2-ASN.mmdb';
$reader2 = new Reader($databasePath2);
$record2 = $reader2->get($clientIp);

// Look up the location information for the IP address
$record = $reader->get($clientIp);

// Display the location information

function get_user_os() {
    $user_agent = $_SERVER['HTTP_USER_AGENT'];

    $os_platform  = "Unknown OS Platform";

    $os_array = array(
        '/windows nt 10/i'      =>  'Windows 10',
        '/windows nt 6.3/i'     =>  'Windows 8.1',
        '/windows nt 6.2/i'     =>  'Windows 8',
        '/windows nt 6.1/i'     =>  'Windows 7',
        '/windows nt 6.0/i'     =>  'Windows Vista',
        '/windows nt 5.2/i'     =>  'Windows Server 2003/XP x64',
        '/windows nt 5.1/i'     =>  'Windows XP',
        '/windows xp/i'         =>  'Windows XP',
        '/windows nt 5.0/i'     =>  'Windows 2000',
        '/windows me/i'         =>  'Windows ME',
        '/win98/i'              =>  'Windows 98',
        '/win95/i'              =>  'Windows 95',
        '/win16/i'              =>  'Windows 3.11',
        '/macintosh|mac os x/i' =>  'Mac OS X',
        '/mac_powerpc/i'        =>  'Mac OS 9',
        '/linux/i'              =>  'Linux',
        '/ubuntu/i'             =>  'Ubuntu',
        '/iphone/i'             =>  'iPhone',
        '/ipod/i'               =>  'iPod',
        '/ipad/i'               =>  'iPad',
        '/android/i'            =>  'Android',
        '/blackberry/i'         =>  'BlackBerry',
        '/webos/i'              =>  'Mobile'
    );

    foreach ($os_array as $regex => $value) {
        if (preg_match($regex, $user_agent)) {
            $os_platform = $value;
        }
    }

    return $os_platform;
}

$user_os = get_user_os();



function get_user_browser() {
    $user_agent = $_SERVER['HTTP_USER_AGENT'];

    $browser = "Unknown Browser";

    $browser_array = array(
        '/msie/i'      => 'Internet Explorer',
        '/firefox/i'   => 'Firefox',
        '/safari/i'    => 'Safari',
        '/chrome/i'    => 'Chrome',
        '/edge/i'      => 'Edge',
        '/opera/i'     => 'Opera',
        '/netscape/i'  => 'Netscape',
        '/maxthon/i'   => 'Maxthon',
        '/konqueror/i' => 'Konqueror',
        '/mobile/i'    => 'Handheld Browser'
    );

    foreach ($browser_array as $regex => $value) {
        if (preg_match($regex, $user_agent)) {
            $browser = $value;
        }
    }

    return $browser;
}

$user_browser = get_user_browser();

    $url = "https://ipinfo.io/$clientIp/json";
    $response = file_get_contents($url);
    $data = json_decode($response, true);
    
 if($record['city']['names']['en']==false){
     $ipinfo = '{
  "ip": "'.$clientIp.'",
  "city": "'.$data['city'].'",
  "region": "'.$data['region'].'",
  "countrycode": "'.$data['country'].'",
  "postalcode": "'.$data['postal'].'",
  "loc": "'.$data['loc'].'",
  "time_zone": "'.$data['timezone'].'",
  "org": "'.$data['org'].'",
  "browser": "'.$user_browser.'",
  "osname": "'.$user_os.'"
}';
 }else{   

$ipinfo = '{
  "ip": "'.$clientIp.'",
  "city": "'.$record['city']['names']['en'].'",
  "region": "'.$record['subdivisions'][0]['names']['en'].'",
  "regioncode": "'.$record['subdivisions'][0]['iso_code'].'",
  "country": "'.$record['country']['names']['en'].'",
  "countrycode": "'.$record['country']['iso_code'].'",
  "postalcode": "'.$record['postal']['code'].'",
  "loc": "'.$record['location']['latitude'].','. $record['location']['longitude'].'",
  "time_zone": "'.$record['location']['time_zone'].'",
  "org": "'.$record2['autonomous_system_organization'].'",
  "continentcode": "'.$record['continent']['code'].'",
  "continentname": "'.$record['continent']['names']['en'].'",
  "browser": "'.$user_browser.'",
  "osname": "'.$user_os.'"
}';
}
print_r($ipinfo);

// Close the GeoIP2 reader
$reader->close();
